<?php

class LDAPAuth
{

	public static function disable_login_hashing()
	{
		global $context;

		$context['disable_login_hashing'] = true;
	}

	public static function login($user, $password, $cookieLength) 
	{

		global $ldapSettings; 

		$db = database();
	
		if (!@extension_loaded('ldap')) {
			require_once(SOURCEDIR . '/Errors.php');
			$error = 'LDAP Extension not Loaded';
			log_error($error, 'general', __FILE__, __LINE__);
			return 'retry';
		}

		$password = $_POST['passwrd'];

		if(empty($ldapSettings['port'])) {
			$ldapConn = ldap_connect($ldapSettings['host']);
		} 
		else {
			$ldapConn = ldap_connect($ldapSettings['host'] , (int)$ldapSettings['port']);
		}

		if($ldapConn === FALSE) {
			require_once(SOURCEDIR . '/Errors.php');
			$error = 'LDAP Connection Failed';
			log_error($error, 'general', __FILE__, __LINE__);
			return 'retry';
		}
		
		ldap_set_option($ldapConn, LDAP_OPT_PROTOCOL_VERSION, 3);
		ldap_set_option($ldapConn, LDAP_OPT_REFERRALS, 0);

		if($ldapConn) {
			$ldapbind = ldap_bind($ldapConn, $ldapSettings['rdn'], $ldapSettings['pass']); 

			if ($ldapbind) {
				$filter			= "(uid=$user)";
				$ldapSearch	= ldap_search($ldapConn, $ldapSettings['dn'], $filter);
				if(ldap_count_entries($ldapConn, $ldapSearch) > 0 ) { 
					$ldapEntry 		= ldap_first_entry($ldapConn,$ldapSearch);
					do // Loop through them until we find the one we want 
					{ 
						if($ldapEntry === false) break; 
						$userDn		= ldap_get_dn($ldapConn,$ldapEntry);
						$ldapbind	= @ldap_bind($ldapConn, $userDn, $password);
						if($ldapbind) {
							$ldapattrs	= ldap_get_attributes($ldapConn,$ldapEntry);


							// verify user exists in forum user database
							$request = $db->query('', '
									SELECT id_member, member_name, passwd, password_salt
									FROM {db_prefix}members
									WHERE member_name = {string:member_name}
									LIMIT 1',
									array(
										'member_name' => $user,
									)
							);

							if ($db->num_rows($request) == 0) { 
								$db->free_result($request);

								if(isset($ldapattrs['givenName'][0])) {
									$realName			= $ldapattrs['givenName'][0];
								} 
								else {
									$realName			= $user;
								}

								if(isset($ldapattrs['mail'][0])) { 
									$emailAddress	= $ldapattrs['mail'][0];
								}
								else {
									return 'please create a valid email address';
								}

								// User does not exist in Elkarte database - create it
								require_once(SOURCEDIR . '/subs/Members.subs.php');
								$regOptions = array (
										'username' => $user,
										'email' => $emailAddress,
										'password' => $password ,
										'password_check' => $password,
										'password_salt' => substr(md5(mt_rand()), 0, 4) ,
										'posts' => 0,
										'check_password_strength' => false,
										'check_email_ban' => false,
										'send_welcome_email' => false,
										'require' => 'nothing',
										'interface' => 'guest',
										'date_registered' => time(),
										'ip' => '',
										'ip2' => '',
										'is_activated' => 1,
										'validation_code' => '',
										'extra_register_vars' => array (
											'real_name' => $realName,
										),
								);
								registerMember($regOptions);
								updateStats('member');
								// If it's enabled, increase the registrations for today.
								trackStats(array('registers' => '+'));
								return 'success';
							}
							elseif ($db->num_rows($request) == 1) {
								// Check the password still matches the one on Elkarte, if not update it
								$userSettings = $db->fetch_assoc($request);
								$db->free_result($request);
								//TODO check password is the same
								//require_once(SOURCEDIR . '/subs/Members.subs.php');
								//require_once(SOURCEDIR . '/subs/Auth.subs.php');

								//if (!verify_password($userSettings['member_name'], un_htmlspecialchars($password), $userSettings['passwd'])) {
									//$userSettings['passwd'] = password($userSettings['member_name'], un_htmlspecialchars($password));
									//updateMemberData($userSettings['id_member'], array('passwd' => $userSettings['passwd'], 'password_salt' => $userSettings['password_salt'], 'passwd_flood' => ''));
								//}
								return 'success';
							}
						}
					} while ( $ldapEntry = ldap_next_entry($ldapConn,$ldapEntry) );
					ldap_free_result($ldapSearch);
				}
			}
		}

		ldap_close($ldapConn);
		
		return 'retry';

	}

}

?>
